`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 03/23/2020 04:41:15 PM
// Design Name: 
// Module Name: Lab3_5
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Lab5_1(
    f_crystal,
    ssd_ctl,
    D_ssd,
    rst,
    pb_in,
    state,
    LED
    );
     
    input pb_in;
    input f_crystal;
    input rst;
    output [3:0]ssd_ctl;
    output [7:0]D_ssd;
    output state;
    output reg [14:0]LED;
    reg global_decrease;
    
    wire f_out;
    wire [1:0]ssd_clk;
    wire [3:0]digit_0, digit_1;
    wire [3:0]display;
    wire borrow;
    wire count_enable;
    wire pb_debounced;
    wire clk_100;
    wire out_pulse;
    
    always @*
        if((digit_0 == 0 && digit_1 == 0) || count_enable == 0)
            global_decrease = 0;
        else
            global_decrease = 1;
    always @*
    if(digit_0 == 0 && digit_1 == 0)
       LED = 15'b111_1111_1111_1111;
    else
       LED = 0;
    
    Lab3_2 U0(.f_out(f_out), // divided clock output
    .ssd_clk(ssd_clk),
    .f_crystal(f_crystal), // global clock input
    .rst(rst),
    .clk_100(clk_100)); // active low reset

    
    down_counter U1(.value(digit_0), .borrow(borrow),  .clk(f_out),  .decrease(global_decrease),  .rst(rst));
    down_counter_2 U2(.value(digit_1), .decrease(borrow), .clk(f_out), .rst(rst));
    
    
    scan_ctl U3(.ssd_ctl(ssd_ctl), .ssd_in1(digit_0), .ssd_in2(digit_1), .ssd_in(display), .ssd_ctl_clk(ssd_clk), .rst(rst));
    
    Lab2_3 U4(.D_ssd(D_ssd), .i(display));
    
    debounce U_debounce(
      .clk(clk_100), // clock control
      .rst(rst), // reset
      .pb_in(pb_in), //push button input
      .pb_debounced(pb_debounced) // debounced push button output
    );
    
     one_pulse U_onePulse(
     .clk(f_out),  // clock input
     .rst(rst), //active low reset
     .in_trig(pb_debounced), // input trigger
     .out_pulse(out_pulse) // output one pulse 
     );
     
     FSM U_FSM(
     .count_enable(count_enable), // if counter is enabled
     .in(out_pulse), //input control
     .clk(f_out), // global clock signal
     .rst(rst), // high active reset
     .state(state)
     );
     
    
endmodule
